/*
	aid program for installation of ProWesS applications

	ctemp : creates a temporary file on ram1_, named
		ram1_tmp_tempXXX
	where XXX is a number (starting from zero - of course).
	It will create an empty file, and fill in the filename into a global
	varaible for which the name is given as parameter.

	written by Joachim Van der Auwera for PROGS
	(c) 1996 by PROGS, Professional & Graphical Software
	28.09.1996 started
*/

#include <io.h>
#include <str.h>
#include <thing.h>

#define catch(X) do { if (err=(X)) return err; } while (0)
#define GLOBAL_NAME "Global Variables"
#define GLOBAL_GET	0x47455420	/* "GET " */
#define GLOBAL_SET	0x53455420	/* "SET " */

Error init(char *param)
{
	Error err;
	char **params;
	char *name=NULL;
	char fname[IO_MAXFULLNAME];
	Channel chid;
	int i;

	/* pars the command line parameters */
	catch( STRBreak(param,&params) );
	for (i=0 ; params[i] ; i++)
	{
		if (STRSameCI("-path",params[i]))
		{
			if (!params[++i]) return ERR_IPAR;
		}
		else
			name=params[i];
	}
	if (!name) return ERR_IPAR;

	for (i=0 ; i<10000 ; i++)
	{
		STRFormatPut(fname,"ram1_tmp_temp%04d",i);
		err=IOOpen(fname,OPEN_NEW,&chid);
		if (!err) break;
	}
	if (i==10000)
		return ERR_ITNF;
	else
		return THINGCall(GLOBAL_NAME,GLOBAL_SET,2,name,fname);
}
